Thu Oct 11 13:32:00 2007  Chris Moller  <cmoller@redhat.com>

	* module/utracer-base.c: Replaced direct manipulation of
	de_utrace_control->proc_fops with manipulation a copy
	thereof--reflects a change in the 2.6.22 kernel.

Tue Oct  2 23:31:49 2007  Chris Moller  <cmoller@redhat.com>

	* include/utracer-errmsgs.h:
	* include/utracer.h: Minor tweaks for the wrapper.
	* utracer/utracer.c: Minor tweak.

Mon Oct  1 13:35:44 2007  Chris Moller  <cmoller@redhat.com>

	* include/utracer.h:
	* utracer/utracer.c:  More stuff to isolate Java from the system.

Fri Sep 21 11:12:12 2007  Chris Moller  <cmoller@redhat.com>

	* utracer/utracer.c:  Moved uerror() here from udb.

Fri Sep 21 11:02:42 2007  Chris Moller  <cmoller@redhat.com>

	* Extensive re-write to further isolate OS-dependent code from Java.

Thu Aug 30 20:34:55 2007  Chris Moller  <cmoller@redhat.com>

	* Added copyright notices to all files.

Mon Aug 27 10:31:26 2007  Chris Moller  <cmoller@redhat.com>

	* module/utracer-cf-io.c: Fixed real fumducker bug in handle_register.

Thu Aug 23 16:55:40 2007  Chris Moller  <cmoller@redhat.com>

	* include/utracer.h:
	* module/utracer-base.c:
	* module/utracer-cf-io.c:
	* module/utracer-if-io.c:
	* module/utracer-private.h:
	* utracer/utracer.c: Move register/unregister stuff to ioctl.

Tue Aug 14 10:32:18 2007  Chris Moller  <cmoller@redhat.com>

	* include/utracer.h:
	* module/utracer-if-io.c:
	* module/utracer-ioctl.c:
	* utracer/utracer.c: Move detach_fcn and sync functions to ioctl.
	
Mon Aug  6 12:03:18 2007  Chris Moller  <cmoller@redhat.com>

	* include/utracer.h:
	* module/utracer-if-io.c:
	* module/utracer-ioctl.c:
	* utracer/utracer.c: Move quiesce and run cmds to ioctl.

Mon Aug  6 10:42:01 2007  Chris Moller  <cmoller@redhat.com>

	* module/utracer-if-io.c:  Added auto-attach.  Added auto-detach
	on report_death.

Thu Aug  2 10:01:13 2007  Chris Moller  <cmoller@redhat.com>

	* include/utracer.h: Removed switchpid and attach response stuff.
	Changed switchpid, attach, and watch from write() to ioctl()
	methods.
	* module/utracer-if-io.c: Removed switchpid and attach code--moved
	to ioctl.
	* utracer/utracer.c:
	* module/utracer-ioctl.c: Added switchpid and attach code from
	utracer-if-io.c. 

Tue Jul 31 13:18:42 2007  Chris Moller  <cmoller@redhat.com>

	* include/utracer.h:
	* module/utracer-if-io.c: Removed syscall cmd stuff from here and
	to ioctl.
	* module/utracer-ioctl.c: Fixed potential gotcha in getting user
	pages.  Moved syscall cmd stuff here from front-end.
	* utracer/utracer.c: Moved syscall cmd stuff here from front-end.

Sat Jul 28 10:02:12 2007  Chris Moller  <cmoller@redhat.com>

	* include/utracer-errmsgs.h: A couple of new error msgs.
	* include/utracer.h: The same plus other minor tweaking.
	* module/utracer-if-io.c:  Removed readreg stuff and put it in
	ioctl.
	* module/utracer-ioctl.c: Moved readreg stuff here.
	* utracer/utracer.c: Added readreg entry point.

Thu Jul 26 14:09:42 2007  Chris Moller  <cmoller@redhat.com>

	* include/utracer-errmsgs.h: Minor bug  fix.
	* module/utracer-ioctl.c:
	* utracer/utracer.c: 
	* include/utracer.h: Added stuff to support /proc/<pid>/mem emulation.

Thu Jul 26 11:52:01 2007  Chris Moller  <cmoller@redhat.com>

	* include/utracer.h: Fixed listpids stuff.
	* module/Makefile: Added utracer-ioctl.o to utracer-objs.
	* module/utracer-cf-io.c:Cleaned up #includes.  Moved some handlers to
	utracer-ioctl.c.
	* module/utracer-base.c: Cleaned up #includes.
	* module/utracer-if-io.c: Cleaned up #includes.  Moved listpids to
	utracer-ioctl.c.
	* utracer/utracer.c: Added listpids code.

Wed Jul 25 21:01:21 2007  Chris Moller  <cmoller@redhat.com>

	* module/utracer-cf-io.c: Fixed a rather egregious abuse of the
	length arg of get_user_pages().

Wed Jul 25 17:22:20 2007  Chris Moller  <cmoller@redhat.com>

	* utracer: New directory added to hold public i/f code to the
	module.
	* utracer/utracer.c: New file for public i/f code (swiped and
	adapted from the old udb-utrace-if.c.)
	* include/utracer.h: Added/modded stuff for new public i/f.

Tue Jul 24 14:04:25 2007  Chris Moller  <cmoller@redhat.com>

	* include:
	* module:  Added two new dirs and moved the "public" headers to
	the include dir and everything else to the module dir.  This is in
	aid of coupling the user-space end of the read, write, and ioctl
	ops more closely to the module (instead of to the front-end) in
	preparation for writing a Java wrapper.

Mon Jul 23 23:27:48 2007  Chris Moller  <cmoller@redhat.com>

	* utracer-cf-io.c: Removed dead code. Added ioctl-based query code
	removed from utracer-if-io.c.
	* utracer-errmsgs.h: Added another error message.
	* utracer-if-io.c: Removed cmd-response query code to utracer-cf-io.c.
	* utracer.h: Changed structs to accomdate ioctl vs. cmd-response
	path. 

Fri Jul 20 12:02:38 2007  Chris Moller  <cmoller@redhat.com>

	* utracer-base.c:
	* utracer-cf-io.c:
	* utracer-if-io.c:
	* utracer-private.h:  Added code to extract and report both the
	supplied filename and the interpreted filename of the binary
	corresponding to the current task.

Fri Jul 20 00:01:02 2007  Chris Moller  <cmoller@redhat.com>

	* utracer-base.c: Removed the experimental ioctl code.
	* utracer-cf-io.c: Added the real ioctl code.  Added the printenv
	code using the ioctl path.
	* utracer-if-io.c: Removed experimental printenv code.
	* utracer.h:
	* utracer-private.h: Added support for ioctl code.

Thu Jul 19 11:41:27 2007  Chris Moller  <cmoller@redhat.com>

	* utracer-base.c: Added code to synchronise the udb control
	thread, the udb listener thread, and the module.  Still needs
	work.  Added code to support ioctl ops to the kernel.  Kind of
	experimental, but works so far.
	* utracer-cf-io.c: Made the cmd file readable--part of the
	synchronisation stuff.
	* utracer-if-io.c: More synchronisation stuff.  Added stuff trying
	to make the equivalent of /proc/<pid>/mem work; still busted,
	needs work.
	* utracer-private.h:  Clean-up and more synchronisation stuff.

Tue Jul 10 11:38:09 2007  Chris Moller  <cmoller@redhat.com>

	* utracer-base.c: Added initialisation for write proc wait queue.
	* utracer-if-io.c:  Extensive refactoring.  Added syn cmd
	processing.  Added a waitqueue to if_file_write to handle batched
	commands.
	* utracer-private.h: Added support for write wait qqueue.
	* utracer.h: Added support for sync command.

Mon Jul  9 15:32:41 2007  Chris Moller  <cmoller@redhat.com>

	* utracer-if-io.c: Minor cleanup.
	* utracer-private.h:
	* utracer.h:
	* utracer-cf-io.c: 
	* utracer-base.c: Switched to new /proc/utrace directory
	structure. 

Fri Jul  6 12:14:31 2007  Chris Moller  <cmoller@redhat.com>

	* utracer-if-io.c:
	* utracer.h: Added a printmmap command.  (All this produces the
	same results as obtained via /proc/<pid>/maps, plus a bit more.) 

Wed Jul  4 12:42:54 2007  Chris Moller  <cmoller@redhat.com>

	* utracer-if-io.c:
	* utracer.h: Added quiesce response.

Wed Jul  4 12:03:47 2007  Chris Moller  <cmoller@redhat.com>

	* utracer-errmsgs.h: Added an error string for non-quiesced task.
	* utracer.h: Added non-quiesced task error code.
	* utracer-if-io.c: Added check in readreg for quiesced task.

Tue Jul  3 12:04:42 2007  Chris Moller  <cmoller@redhat.com>

	* utracer-errmsgs.h: Fixed typo.

Tue Jul  3 11:13:16 2007  Chris Moller  <cmoller@redhat.com>

	* utracer-base.c: Added initialisation for syscall reporting
	filter bitvec.
	* utracer-errmsgs.h: Added "syscall nr out of range" error string.
	* utracer-if-io.c: Added filtering to syscall reporting.  Added
	syscall filter command processing.
	* utracer-private.h: Added syscall filtering support and bitvec
	set/clear/test macros.

Sun Jul  1 16:32:53 2007  Chris Moller  <cmoller@redhat.com>

	* utracer-if-io.c:
	* utracer.h: Added controls to enable, disable, and filter
	syscalls. (INCOMPLETE) 
	

Sat Jun 30 22:11:38 2007  Chris Moller  <cmoller@redhat.com>

	* utracer.h: 
	* utracer-if-io.c: Added code to queue report_exec data to the
	client.

Fri Jun 29 12:08:53 2007  Chris Moller  <cmoller@redhat.com>

	* utracer-if-io.c:
	* utracer.h:  Added support for syscall reports.

Thu Jun 28 23:34:32 2007  Chris Moller  <cmoller@redhat.com>

	* utracer-base.c: Added support for selectively execing a pgm and
	immediately quiescing it, or execing it and running it.
	* utracer-if-io.c: Same as above.
	* utracer-private.h: Same as above.
	* utracer.h: Same as above.

Thu Jun 28 20:50:15 2007  Chris Moller  <cmoller@redhat.com>

	* utracer-if-io.c: Fixed fork/attach/exec--it forks, attaches, and
	execs, then quiesces.  (Note to self:  add option to not quiesce for
	report_syscall_* and other on-the-fly monitoring.)

Thu Jun 28 18:11:58 2007  Chris Moller  <cmoller@redhat.com>

	* utracer-if-io.c: Added support for the switchpid command.
	* utracer.h: Added support for the switchpid command.

Wed Jun 27 23:30:11 2007  Chris Moller  <cmoller@redhat.com>

	* utracer-if-io.c: Added support for dumping all available registers.

Wed Jun 27 21:43:57 2007  Chris Moller  <cmoller@redhat.com>

	* utracer-if-io.c: Added a means of including data of arbitrary
	size to responses (e.g., the list of attached PIDs).  Adding
	support for death and exit reporting.  Added support for attaching
	without quiescing.  Added support for listing attached processes.
	Fixed if_file_read().  (Note to self: check for negative array
	indices /before/ spending two days wondering how a simple wait
	queue can blow up a kernel.)
	* utracer.h: Add support for all the above.

Wed Jun 19 23:25:20 2007  Chris Moller  <cmoller@redhat.com>

	* utracer-if-io.c: Added responses for report_exit and
	report_death.  Added a passive attach (Attaches a process but
	doesn't quiesce it.).
	* utracer.h:  Patched to accomdate the above.

2007-06-18  Chris Moller  <moller@mollerware.com>

	* utracer-base.c: Separated the single utraced-specific if_cmd
	file into a write-only cmd file and a read-only response file.
	* utracer-cf-io.c: Patched to accomodate above.  Cleaned up
	diagnostic code.
	* utracer-if-io.c: Added a wait queue to the if_resp fcn to block
	until data is ready, allowing the userspace debugger to select() on
	input from the LKM.  Cleaned up diagnostic code.  Added a wait
	queue to make sure queued data isn't overwritten.  Added responses
	for clone and signal asynchronous events.  Added response for
	attach cmd.
	* utracer-private.h: Patched to accomdate the above.  

2007-06-15  Chris Moller  <moller@mollerware.com>

	* utracer-cf-io.c: Added a mechanism to utrace_attach() the
	debugging client to watch for the death of the client.
	* utracer-if-io.c: Added the LKM end of the asynchronous client
	notification testcase stuff (signal injection).
	* utracer.h: Added support for the async stuff.

2007-06-13  Chris Moller  <moller@mollerware.com>

	* utracer-errmsgs.h: New file
	* utracer.h: Added utrace-specific errnos.
	* utracer-base.c: Added utrace-specific errnos.
	* utracer-cf-io.c: Added utrace-specific errnos.
	* utracer-if-io.c: Added utrace-specific errnos.  Added more
	report_* functions
	

2007-06-12  Chris Moller  <moller@mollerware.com>

	* ChangeLog:
	* .cvsignore:
	* Makefile:
	* utracer-base.c:
	* utracer-cf-io.c:
	* utracer-if-io.c:
	* utracer-private.h:
	* utracer.h:  Version 0.0.0.0.0.0
	

